﻿Imports System.Console
Module Module1
    Structure TriatlonStruc
        Dim Név As String
        Dim Úszás As Integer
        Dim Kerékpár As Integer
        Dim Futás As Integer
        Dim Összes As Integer
        Dim ÓPM As String
    End Structure
    Private Tria(100) As TriatlonStruc
    Private n As Integer    'A versenyzők száma

    Sub Main()
        WriteLine("Triatlon")
        WriteLine()
        WriteLine("Adatok beolvasása...")
        Feladat1()
        WriteLine()
        WriteLine("Az első három versenyző:")
        Feladat2()
        WriteLine()
        WriteLine("Az első versenyző adatai:")
        Feladat3()
        WriteLine()
        WriteLine("Konvertálás óó:pp:ss alakba:")
        Feladat4()
        WriteLine()
        WriteLine("Időeredmények fájlba írása...")
        Feladat5()
        WriteLine()
        WriteLine("Egyes számok győztesei:")
        Feladat7()
        WriteLine()
        ReadLine()
    End Sub

    Sub Feladat7()
        Dim minh As Integer
        Dim min As Integer
        Dim óó As Integer
        Dim pp As Integer
        Dim ss As Integer

        minh = 1
        min = Tria(1).Úszás
        For i As Integer = 2 To n
            If min > Tria(i).Úszás Then
                minh = i
                min = Tria(i).Úszás
            End If
        Next
        ss = min
        óó = ss \ 3600
        ss = ss Mod 3600
        pp = ss \ 60
        ss = ss Mod 60
        Dim úsz As New TimeSpan(óó, pp, ss)
        WriteLine("Úszásban: " & Tria(minh).Név & " " & úsz.ToString)

        minh = 1
        min = Tria(1).Kerékpár
        For i As Integer = 2 To n
            If min > Tria(i).Kerékpár Then
                minh = i
                min = Tria(i).Kerékpár
            End If
        Next
        ss = min
        óó = ss \ 3600
        ss = ss Mod 3600
        pp = ss \ 60
        ss = ss Mod 60
        Dim ker As New TimeSpan(óó, pp, ss)
        WriteLine("Kerékpározásban: " & Tria(minh).Név & " " & ker.ToString)

        minh = 1
        min = Tria(1).Futás
        For i As Integer = 2 To n
            If min > Tria(i).Futás Then
                minh = i
                min = Tria(i).Futás
            End If
        Next
        ss = min
        óó = ss \ 3600
        ss = ss Mod 3600
        pp = ss \ 60
        ss = ss Mod 60
        Dim fut As New TimeSpan(óó, pp, ss)
        WriteLine("Futásban: " & Tria(minh).Név & " " & fut.ToString)
    End Sub


    Sub Feladat5()
        Dim fájl As IO.FileStream = New IO.FileStream("../../triatlon.ki", IO.FileMode.Create)
        Dim író As IO.StreamWriter = New IO.StreamWriter(fájl)

        For i As Integer = 1 To n
            író.WriteLine(Tria(i).Név & " " & Tria(1).ÓPM)
        Next
        író.Close()
        fájl.Close()
    End Sub


    Sub Feladat4()
        For i As Integer = 1 To n
            Dim ss As Integer = Tria(i).Összes
            Dim óó As Integer = ss \ 3600
            ss = ss Mod 3600
            Dim pp As Integer = ss \ 60
            ss = ss Mod 60
            Dim össz As New TimeSpan(óó, pp, ss)
            Tria(i).ÓPM = össz.ToString
            WriteLine(Tria(i).Név & " " & Tria(i).ÓPM)
        Next

    End Sub

    Sub Feladat3()
        WriteLine("Neve: " & Tria(1).Név)
        WriteLine("Úszásban: " & 1.5 / (Tria(1).Úszás / 3600) & " km/h")
        WriteLine("Kerékpározásban: " & 40 / (Tria(1).Kerékpár / 3600) & " km/h")
        WriteLine("Futásban: " & 10 / (Tria(1).Futás / 3600) & " km/h")
    End Sub

    Sub Feladat2()
        Dim b As TriatlonStruc
        For i As Integer = 1 To n
            For j As Integer = 1 To n - i
                If Tria(j).Összes > Tria(j + 1).Összes Then
                    b = Tria(j)
                    Tria(j) = Tria(j + 1)
                    Tria(j + 1) = b
                End If
            Next
        Next

        For i As Integer = 1 To 3
            WriteLine(i & ". " & Tria(i).Név & " " & Tria(i).Összes)
        Next
    End Sub

    Sub Feladat1()
        Dim fájl As IO.FileStream = New IO.FileStream("../../triatlon.be", IO.FileMode.Open)
        Dim olvasó As IO.StreamReader = New IO.StreamReader(fájl)

        n = CInt(olvasó.ReadLine())
        For i As Integer = 1 To n
            Tria(i).Név = olvasó.ReadLine()
            Tria(i).Úszás = CInt(olvasó.ReadLine())
            Tria(i).Kerékpár = CInt(olvasó.ReadLine())
            Tria(i).Futás = CInt(olvasó.ReadLine())
            Tria(i).Összes = Tria(i).Úszás + Tria(i).Kerékpár + Tria(i).Futás
        Next
        olvasó.Close()
        fájl.Close()
    End Sub

End Module
